{
  This file was automatically generated on 2012-07-26.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletTemperature;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE = 1;
  BRICKLET_TEMPERATURE_FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD = 2;
  BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD = 3;
  BRICKLET_TEMPERATURE_FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD = 4;
  BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD = 5;
  BRICKLET_TEMPERATURE_FUNCTION_SET_DEBOUNCE_PERIOD = 6;
  BRICKLET_TEMPERATURE_FUNCTION_GET_DEBOUNCE_PERIOD = 7;
  BRICKLET_TEMPERATURE_CALLBACK_TEMPERATURE = 8;
  BRICKLET_TEMPERATURE_CALLBACK_TEMPERATURE_REACHED = 9;

type
  TBrickletTemperatureNotifyTemperature = procedure(const temperature: smallint) of object;
  TBrickletTemperatureNotifyTemperatureReached = procedure(const temperature: smallint) of object;

  TBrickletTemperature = class(TDevice)
  private
    temperatureCallback: TBrickletTemperatureNotifyTemperature;
    temperatureReachedCallback: TBrickletTemperatureNotifyTemperatureReached;
  protected
    procedure CallbackWrapperTemperature(const packet: TByteArray); virtual;
    procedure CallbackWrapperTemperatureReached(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    function GetTemperature: smallint; virtual;
    procedure SetTemperatureCallbackPeriod(const period: longword); virtual;
    function GetTemperatureCallbackPeriod: longword; virtual;
    procedure SetTemperatureCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetTemperatureCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnTemperature: TBrickletTemperatureNotifyTemperature read temperatureCallback write temperatureCallback;
    property OnTemperatureReached: TBrickletTemperatureNotifyTemperatureReached read temperatureReachedCallback write temperatureReachedCallback;
  end;

implementation

constructor TBrickletTemperature.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Temperature Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_TEMPERATURE_CALLBACK_TEMPERATURE] := {$ifdef FPC}@{$endif}CallbackWrapperTemperature;
  callbackWrappers[BRICKLET_TEMPERATURE_CALLBACK_TEMPERATURE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperTemperatureReached;
end;

function TBrickletTemperature.GetTemperature: smallint;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE, response);
  result := LEConvertInt16From(4, response);
end;

procedure TBrickletTemperature.SetTemperatureCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_FUNCTION_SET_TEMPERATURE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletTemperature.GetTemperatureCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletTemperature.SetTemperatureCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_FUNCTION_SET_TEMPERATURE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletTemperature.GetTemperatureCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_FUNCTION_GET_TEMPERATURE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletTemperature.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletTemperature.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_TEMPERATURE_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_TEMPERATURE_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletTemperature.CallbackWrapperTemperature(const packet: TByteArray);
var temperature: smallint;
begin
  if (Assigned(temperatureCallback)) then begin
    temperature := LEConvertInt16From(4, packet);
    temperatureCallback(temperature);
  end;
end;

procedure TBrickletTemperature.CallbackWrapperTemperatureReached(const packet: TByteArray);
var temperature: smallint;
begin
  if (Assigned(temperatureReachedCallback)) then begin
    temperature := LEConvertInt16From(4, packet);
    temperatureReachedCallback(temperature);
  end;
end;

end.
