{
  This file was automatically generated on 2012-07-26.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletVoltage;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE = 1;
  BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE = 2;
  BRICKLET_VOLTAGE_FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD = 3;
  BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD = 4;
  BRICKLET_VOLTAGE_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD = 5;
  BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD = 6;
  BRICKLET_VOLTAGE_FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD = 7;
  BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD = 8;
  BRICKLET_VOLTAGE_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD = 9;
  BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD = 10;
  BRICKLET_VOLTAGE_FUNCTION_SET_DEBOUNCE_PERIOD = 11;
  BRICKLET_VOLTAGE_FUNCTION_GET_DEBOUNCE_PERIOD = 12;
  BRICKLET_VOLTAGE_CALLBACK_VOLTAGE = 13;
  BRICKLET_VOLTAGE_CALLBACK_ANALOG_VALUE = 14;
  BRICKLET_VOLTAGE_CALLBACK_VOLTAGE_REACHED = 15;
  BRICKLET_VOLTAGE_CALLBACK_ANALOG_VALUE_REACHED = 16;

type
  TBrickletVoltageNotifyVoltage = procedure(const voltage: word) of object;
  TBrickletVoltageNotifyAnalogValue = procedure(const value: word) of object;
  TBrickletVoltageNotifyVoltageReached = procedure(const voltage: word) of object;
  TBrickletVoltageNotifyAnalogValueReached = procedure(const value: word) of object;

  TBrickletVoltage = class(TDevice)
  private
    voltageCallback: TBrickletVoltageNotifyVoltage;
    analogValueCallback: TBrickletVoltageNotifyAnalogValue;
    voltageReachedCallback: TBrickletVoltageNotifyVoltageReached;
    analogValueReachedCallback: TBrickletVoltageNotifyAnalogValueReached;
  protected
    procedure CallbackWrapperVoltage(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValue(const packet: TByteArray); virtual;
    procedure CallbackWrapperVoltageReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperAnalogValueReached(const packet: TByteArray); virtual;
  public
    constructor Create(const uid_: string);
    function GetVoltage: word; virtual;
    function GetAnalogValue: word; virtual;
    procedure SetVoltageCallbackPeriod(const period: longword); virtual;
    function GetVoltageCallbackPeriod: longword; virtual;
    procedure SetAnalogValueCallbackPeriod(const period: longword); virtual;
    function GetAnalogValueCallbackPeriod: longword; virtual;
    procedure SetVoltageCallbackThreshold(const option: char; const min: smallint; const max: smallint); virtual;
    procedure GetVoltageCallbackThreshold(out option: char; out min: smallint; out max: smallint); virtual;
    procedure SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word); virtual;
    procedure GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word); virtual;
    procedure SetDebouncePeriod(const debounce: longword); virtual;
    function GetDebouncePeriod: longword; virtual;
    property OnVoltage: TBrickletVoltageNotifyVoltage read voltageCallback write voltageCallback;
    property OnAnalogValue: TBrickletVoltageNotifyAnalogValue read analogValueCallback write analogValueCallback;
    property OnVoltageReached: TBrickletVoltageNotifyVoltageReached read voltageReachedCallback write voltageReachedCallback;
    property OnAnalogValueReached: TBrickletVoltageNotifyAnalogValueReached read analogValueReachedCallback write analogValueReachedCallback;
  end;

implementation

constructor TBrickletVoltage.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Voltage Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_VOLTAGE_CALLBACK_VOLTAGE] := {$ifdef FPC}@{$endif}CallbackWrapperVoltage;
  callbackWrappers[BRICKLET_VOLTAGE_CALLBACK_ANALOG_VALUE] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValue;
  callbackWrappers[BRICKLET_VOLTAGE_CALLBACK_VOLTAGE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperVoltageReached;
  callbackWrappers[BRICKLET_VOLTAGE_CALLBACK_ANALOG_VALUE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAnalogValueReached;
end;

function TBrickletVoltage.GetVoltage: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE, response);
  result := LEConvertUInt16From(4, response);
end;

function TBrickletVoltage.GetAnalogValue: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletVoltage.SetVoltageCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_SET_VOLTAGE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletVoltage.GetVoltageCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletVoltage.SetAnalogValueCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_SET_ANALOG_VALUE_CALLBACK_PERIOD, 8);
  LEConvertUInt32To(period, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletVoltage.GetAnalogValueCallbackPeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE_CALLBACK_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletVoltage.SetVoltageCallbackThreshold(const option: char; const min: smallint; const max: smallint);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_SET_VOLTAGE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertInt16To(min, 5, request);
  LEConvertInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletVoltage.GetVoltageCallbackThreshold(out option: char; out min: smallint; out max: smallint);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_VOLTAGE_FUNCTION_GET_VOLTAGE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertInt16From(5, response);
  max := LEConvertInt16From(7, response);
end;

procedure TBrickletVoltage.SetAnalogValueCallbackThreshold(const option: char; const min: word; const max: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_SET_ANALOG_VALUE_CALLBACK_THRESHOLD, 9);
  LEConvertCharTo(option, 4, request);
  LEConvertUInt16To(min, 5, request);
  LEConvertUInt16To(max, 7, request);
  SendRequestNoResponse(request);
end;

procedure TBrickletVoltage.GetAnalogValueCallbackThreshold(out option: char; out min: word; out max: word);
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_VOLTAGE_FUNCTION_GET_ANALOG_VALUE_CALLBACK_THRESHOLD, response);
  option := LEConvertCharFrom(4, response);
  min := LEConvertUInt16From(5, response);
  max := LEConvertUInt16From(7, response);
end;

procedure TBrickletVoltage.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletVoltage.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_VOLTAGE_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_VOLTAGE_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletVoltage.CallbackWrapperVoltage(const packet: TByteArray);
var voltage: word;
begin
  if (Assigned(voltageCallback)) then begin
    voltage := LEConvertUInt16From(4, packet);
    voltageCallback(voltage);
  end;
end;

procedure TBrickletVoltage.CallbackWrapperAnalogValue(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueCallback(value);
  end;
end;

procedure TBrickletVoltage.CallbackWrapperVoltageReached(const packet: TByteArray);
var voltage: word;
begin
  if (Assigned(voltageReachedCallback)) then begin
    voltage := LEConvertUInt16From(4, packet);
    voltageReachedCallback(voltage);
  end;
end;

procedure TBrickletVoltage.CallbackWrapperAnalogValueReached(const packet: TByteArray);
var value: word;
begin
  if (Assigned(analogValueReachedCallback)) then begin
    value := LEConvertUInt16From(4, packet);
    analogValueReachedCallback(value);
  end;
end;

end.
